/*
** fpkview
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <piece.h>

#include "filepack.h"

char *g_pkfn = "pceapi2.fpk";

enum {
	MODE_FILELIST = 0,
	MODE_TEXTVIEW,
}nMode;

int nSceneCnt = 0;

#define	HEADER_HIGH			8

#define FONT_H	10
#define FONT_W	5

#define LISTFONT_H	6
#define LISTFONT_W	3
#define LISTSTR_H	(LISTFONT_H+1)

#define	FILELISTNUM		11

// t@CXgp
#define	FILELIST_BASE_Y		10
int nCursor = 0;
int nPage = 0;
int nMaxFiles;

// eLXgrAp
#define	TEXTVIEW_LINEMAX	19999
#define	TEXTVIEW_VIEWLINES	8

int nLineCnt = 0;
int nLineMax = 0;
unsigned long pLineBuf[TEXTVIEW_LINEMAX];

#define MAXTMPSIZE 8192
BYTE tmp[MAXTMPSIZE];


/////////////////////////////////////////////////////
// dispray
unsigned char vbuff[ 128 * 88 ];
BOOL nVramUpdate = TRUE;

BOOL is_vram_update(){
	return nVramUpdate;
}
void update_dispray(){
	nVramUpdate = TRUE;
}
void rendered_dispray(){
	nVramUpdate = FALSE;	
}
void clear_vram(){
	memset( vbuff, 0, 128*88 );
}

///////////////////////////////////////////////
// file

int nFileNum = -1;

//public:
void set_file_num(int num){
	nFileNum = num;
}
int get_file_num(){
	return nFileNum;
}

const char* const get_filename(int n){
	return FPK_FileNameIndex(g_pkfn,n);
}
const char* const get_now_filename(){
	return get_filename(get_file_num());
}


////////////////////////////////////////////////
// funcs

void DrawHeader( char *szMes ) {
	pceLCDPaint(2,0,0,128,HEADER_HIGH);
	pceFontSetType(0);
	pceFontSetBkColor( -1 );
	pceFontSetTxColor( 0 );
	pceFontSetPos( 0, -1 );
	pceFontPrintf( szMes );
	pceFontSetBkColor( 0 );
	pceFontSetTxColor( 3 );
}

BOOL IsKanji( unsigned char cData ) {
	if ( cData < 0x81 ) { return FALSE;	}
	if ( cData < 0xa0 ) { return TRUE;	}
	if ( cData < 0xe0 ) { return FALSE;	}
	if ( cData < 0xff ) { return TRUE;	}
	return FALSE;
}



// nPage0.
// t@C߂
int DrawFileList( int nPage ) {
	
	int base_y = HEADER_HIGH;
	DWORD n = 0;
	int i;
	
	DrawHeader( "API Viewer v01" );
	pceLCDPaint(0,0,base_y,128,88-base_y);
	pceFontSetType(2);
	

	if(!FPK_PackedFileNum(g_pkfn,&n)){
		return 0;
	}
	
	for(i=0; i<n; i++) {
		if(get_filename(i)==NULL)
			break;
		if ( i / FILELISTNUM == nPage ) {
			pceFontSetPos( 8, FILELIST_BASE_Y + ( i % FILELISTNUM ) * LISTSTR_H );
			pceFontPrintf( "%s",get_filename(i) );
		}
	}
	update_dispray();
	return n;
}



void DrawTextView( unsigned long nPnt ) {
	int x = 0, y = 0;
	int base_x = 0, base_y = 8;
	DWORD size;
	BYTE *p;
	char str[256];
	
	size = FPK_GetPackFileData(g_pkfn,get_now_filename(),tmp,0,MAXTMPSIZE);
	p=tmp;
	if(size==0){
		DrawHeader( "read error!" );
		return;
	}

	DrawHeader( get_now_filename() );
	pceLCDPaint(0,0,base_y,128,88-base_y);

	pceFontSetType(0);

	while( nPnt < size ) {
		if ( IsKanji( p[nPnt] ) ) {
			if ( base_x + ( x + 2 ) * FONT_W > 128 ) {
				x = base_x; y++;
			}
			if ( base_y + ( y + 1 ) * FONT_H > 88 ) {
				break;
			}
			pceFontSetPos( base_x + x * FONT_W, base_y + y * FONT_H );
			pceFontPrintf( "%c%c", p[nPnt], p[nPnt+1] );
			x += 2; nPnt += 2;
		} else {
			if ( p[nPnt] == 0x0d ) {
				nPnt++;
				if ( p[nPnt] == 0x0a ) {
					nPnt++;
				}
				x = base_x; y++;
			} else {
				if ( base_x + ( x + 1 ) * FONT_W > 128 ) {
					x = base_x; y ++;
				} else {
					pceFontSetPos( base_x + x * FONT_W, base_y + y * FONT_H );
					if ( p[nPnt] < ' ' ) {
						pceFontPrintf( " " );
					} else {
						pceFontPrintf( "%c", p[nPnt] );
					}
					x++; nPnt++;
				}
			}
			if ( base_y + ( y + 1 ) * FONT_H > 88 ) {
				break;
			}
		}
	}
	
}

void CountTextLine() {
	int x = 0, y = 0;
	int base_x = 0;//, base_y = 8;
	int font_w = 5;//, font_h = 10;
	int nPnt = 0;
	
	DWORD size;
	BYTE *p;
	
	size = FPK_GetPackFileData(g_pkfn,get_now_filename(),tmp,0,MAXTMPSIZE);
	p=tmp;
	if(size==0){
		DrawHeader( "read error!" );
		return;
	}
	
	nLineMax = 0;
	pLineBuf[nLineMax] = nPnt;
	nLineMax++;

	while( nPnt < size ) {
		if ( IsKanji( p[nPnt] ) ) {
			if ( base_x + ( x + 2 ) * font_w > 128 ) {
				x = base_x; y++;
				pLineBuf[nLineMax] = nPnt;
				nLineMax++;
			}
			x += 2; nPnt += 2;
		} else {
			if ( p[nPnt] == 0x0d ) {
				nPnt++;
				if ( p[nPnt] == 0x0a ) {
					nPnt++;
				}
				x = base_x; y++;
				pLineBuf[nLineMax] = nPnt;
				nLineMax++;
			} else {
				if ( base_x + ( x + 1 ) * font_w > 128 ) {
					x = base_x; y++;
					pLineBuf[nLineMax] = nPnt;
					nLineMax++;
				} else {
					x++; nPnt++;
				}
			}
		}
	}
}


void pceAppInit( void ) {
	DWORD size;
	BYTE *p;
	
	pceLCDDispStop();
	pceLCDSetBuffer( vbuff );
	pceAppSetProcPeriod( 40 );
	clear_vram();
	
	nMode = MODE_FILELIST;
	
	nMaxFiles = DrawFileList( nPage );

	pceLCDDispStart();
	
	set_file_num(0);
	if(!FPK_FindPackData(g_pkfn,get_now_filename(),&p,&size)){
		pceAppReqExit(-1);
	}

	update_dispray();
}

void pceAppProc( int cnt ) {

	int nBackupMode = nMode;
	unsigned long lKey;
	lKey = pcePadGet();

	if( lKey & TRG_D )
		pceAppReqExit(0);

	switch( nMode ) {
		case MODE_FILELIST:
		{
			int nBackupCursor = nCursor;
			int nBackupPage = nPage;
			if ( nSceneCnt == 0 ) {
				nMaxFiles = DrawFileList( nPage );
			}
			if ( lKey & TRG_UP ) { nCursor--; nSceneCnt = 0; }
			else if ( lKey & TRG_DN ) { nCursor++; nSceneCnt = 0; }
			else if ( lKey & TRG_LF ) { nPage--; nSceneCnt = 0; }
			else if ( lKey & TRG_RI ) { nPage++; nSceneCnt = 0; }
			
			if ( lKey & TRG_A ) {
				nMode = MODE_TEXTVIEW; break;
			}
			else {
				if ( nBackupPage != nPage ) {
					if ( nPage < 0 ) {
						nPage = ( nMaxFiles - 1 ) / FILELISTNUM;
					} else if ( nPage > ( nMaxFiles - 1 ) / FILELISTNUM ) {
						nPage = 0;
					}
					if ( nBackupPage != nPage ) {
						nMaxFiles = DrawFileList( nPage );
					}
				}
				if ( nPage == nMaxFiles / FILELISTNUM ) {
					if ( nCursor < 0 ) {
						nCursor = ( nMaxFiles % FILELISTNUM ) - 1;
					} else if ( nCursor >= nMaxFiles % FILELISTNUM ) {
						nCursor = 0;
					}
				} else {
					if ( nCursor < 0 ) {
						nCursor = FILELISTNUM - 1;
					} else if ( nCursor > FILELISTNUM - 1 ) {
						nCursor = 0;
					}
				}
				
				pceFontSetType(2);
				pceFontSetPos( 2, FILELIST_BASE_Y + nBackupCursor * LISTSTR_H ); pceFontPrintf( " " );
				if ( nSceneCnt%12 < 8 ) {
					pceFontSetPos( 2, FILELIST_BASE_Y + nCursor * LISTSTR_H ); pceFontPrintf( ">" );
				}
				update_dispray();
			}
			
			break;
		}
		case MODE_TEXTVIEW:
		{
			if ( nSceneCnt == 0 ) {			
				if ( get_file_num() != nPage * FILELISTNUM + nCursor ) {
					set_file_num(nPage * FILELISTNUM + nCursor);
					nLineCnt = 0; nLineMax = 0;
				}
				CountTextLine();
				update_dispray();
			}
			if 		( lKey & TRG_UP ) { nLineCnt--; update_dispray(); }
			else if ( lKey & TRG_DN ) { nLineCnt++; update_dispray(); }
			else if ( lKey & TRG_LF ) { nLineCnt -= TEXTVIEW_VIEWLINES; update_dispray(); }
			else if ( lKey & TRG_RI ) { nLineCnt += TEXTVIEW_VIEWLINES; update_dispray(); }
			if ( lKey & TRG_A ) {
				nMode = MODE_FILELIST;
			}
			if ( nLineCnt < 0 ) { nLineCnt = 0; }
			if ( nLineCnt > nLineMax-TEXTVIEW_VIEWLINES-1 ) { nLineCnt = nLineMax-TEXTVIEW_VIEWLINES - 1; }
			if ( is_vram_update() ) {
				DrawTextView( pLineBuf[nLineCnt] );
			}
			break;
		}
	}

	// ʕ\
	if ( is_vram_update() ) {
		pceLCDTrans();
		rendered_dispray();
	}
	if ( nBackupMode == nMode ) {
		nSceneCnt++;
	} else {
		nSceneCnt = 0;
	}
}


void pceAppExit( void ) {
}


